@echo off
SETLOCAL
FOR /f %%a IN ('WMIC OS GET LocalDateTime ^| FIND "."') DO SET DTS=%%a
SET DateTime=%DTS:~0,4%-%DTS:~4,2%-%DTS:~6,2%_%DTS:~8,2%-%DTS:~10,2%-%DTS:~12,2%
set LOGFILE=logASPM-%DateTime%.txt

ECHO Original ASPM settings: > %LOGFILE%
powercfg /Q SCHEME_CURRENT 501a4d13-42af-4429-9fd1-a8218c268e20 >> %LOGFILE%

ECHO Are you sure you want to turn Off Link State Power Management for Current Power Plan (Y/[N])? >> %LOGFILE%
CHOICE /C YN /T 20 /D N /N /M "Are you sure you want to turn Off Link State Power Management for Current Power Plan (Y/[N])?"
if errorlevel 2 goto :NO
:yes
Echo Yes >> %LOGFILE%
ECHO. >> %LOGFILE%
ECHO Turning off ASPM for AC. >> %LOGFILE% 
powercfg /setacvalueindex SCHEME_CURRENT 501a4d13-42af-4429-9fd1-a8218c268e20 ee12f906-d277-404b-b6da-e5fa1a576df5 0 >> %LOGFILE%
ECHO. >> %LOGFILE%
REM ECHO Turning off ASPM for DC. >> %LOGFILE%
REM powercfg /setdcvalueindex SCHEME_CURRENT 501a4d13-42af-4429-9fd1-a8218c268e20 ee12f906-d277-404b-b6da-e5fa1a576df5 0 >> %LOGFILE%
REM ECHO. >> %LOGFILE%
ECHO ASPM settings after a change: >> %LOGFILE%
powercfg /Q SCHEME_CURRENT 501a4d13-42af-4429-9fd1-a8218c268e20 >> %LOGFILE%
goto :END

:NO
ECHO NO >> %LOGFILE%
:END
ENDLOCAL